=== debian/changelog ===
libxeddsa (2.0.0+20221109.06a02c8-2) unstable; urgency=medium

  * Use a map file

 -- Martin <debacle@debian.org>  Sun, 04 Dec 2022 07:12:13 +0000

libxeddsa (2.0.0+20221109.06a02c8-1) unstable; urgency=medium

  * Initial package (Closes: #1023293)

 -- Martin <debacle@debian.org>  Thu, 24 Nov 2022 00:00:21 +0000
