=== debian/control ===
Source: libxeddsa
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Martin <debacle@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
	       debhelper-compat (= 13),
	       doxygen,
	       libsodium-dev,
	       patchelf,
	       pkg-config,
	       python3-breathe,
	       python3-sphinx,
	       python3-sphinx-rtd-theme,
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/xmpp-team/libxeddsa
Vcs-Git: https://salsa.debian.org/xmpp-team/libxeddsa.git
Homepage: https://github.com/Syndace/libxeddsa
Rules-Requires-Root: no

Package: libxeddsa-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libxeddsa2 (= ${binary:Version}),
         ${misc:Depends},
	 ${sphinxdoc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Description: toolkit around Curve25519 and Ed25519 key pairs - development files
 A toolkit around Curve25519 and Ed25519 key pairs, with a focus on
 conversion between the two. Offers:
 .
   - Conversion between Curve25519 and Ed25519 public keys
   - Extraction of private keys from seeds
   - Ed25519 digital signing using seeds or private keys
   - Ed25519 digital signature verification
   - X25519 Diffie-Hellman key agreement
 .
 This package contains the development files.

Package: libxeddsa2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: toolkit around Curve25519 and Ed25519 key pairs - shared library
 A toolkit around Curve25519 and Ed25519 key pairs, with a focus on
 conversion between the two. Offers:
 .
   - Conversion between Curve25519 and Ed25519 public keys
   - Extraction of private keys from seeds
   - Ed25519 digital signing using seeds or private keys
   - Ed25519 digital signature verification
   - X25519 Diffie-Hellman key agreement
 .
 This package contains the shared library.
