=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake --with sphinxdoc

execute_after_dh_auto_build:
	( cd bin/dynamic/; \
          mv libxeddsa.so libxeddsa.so.${DEB_VERSION_UPSTREAM}; \
	  MAJOR=$$(echo ${DEB_VERSION_UPSTREAM} | sed 's/\..*//'); \
          patchelf --set-soname libxeddsa.so.$${MAJOR} libxeddsa.so.${DEB_VERSION_UPSTREAM}; \
	  ln -s libxeddsa.so.${DEB_VERSION_UPSTREAM} libxeddsa.so.$${MAJOR}; \
	  ln -s libxeddsa.so.${DEB_VERSION_UPSTREAM} libxeddsa.so )
	cd docs && $(MAKE) html

override_dh_dwz: # override dwz as it breaks on shlibs edited by patchelf
