## libxeddsa 2.0.0+20231128.d725c81

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(libxeddsa)
+project(libxeddsa VERSION 2.0.0 LANGUAGES C)
 
 include(CTest)
 
@@ -44,14 +44,12 @@
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")
 
-set(sodium_USE_STATIC_LIBS YES)
-find_package(Sodium REQUIRED)
-set(sodium_static_INCLUDE_DIR ${sodium_INCLUDE_DIR})
-
-if (NOT DEFINED EMSCRIPTEN)
+if (DEFINED EMSCRIPTEN)
+    set(sodium_USE_STATIC_LIBS YES)
+    find_package(Sodium REQUIRED)
+else ()
     set(sodium_USE_STATIC_LIBS NO)
     find_package(Sodium REQUIRED)
-    set(sodium_dynamic_INCLUDE_DIR ${sodium_INCLUDE_DIR})
 
     if (WIN32)
         file(COPY "${sodium_DLL_DEBUG}" DESTINATION "${PROJECT_SOURCE_DIR}/bin/")
@@ -66,10 +64,7 @@
 
 include_directories(include)
 include_directories(ref10/include)
-include_directories(${sodium_static_INCLUDE_DIR})
-if (NOT DEFINED EMSCRIPTEN)
-    include_directories(${sodium_dynamic_INCLUDE_DIR})
-endif ()
+include_directories(${sodium_INCLUDE_DIR})
 
 ##########
 # xeddsa #
@@ -107,7 +102,7 @@
     crypto_stream_objects
     crypto_core_objects
     kernelrandombytes_objects
-    sodium_static
+    sodium
 )
 
 install(TARGETS xeddsa_static)
@@ -115,6 +110,11 @@
 if (NOT DEFINED EMSCRIPTEN)
     add_library(xeddsa_dynamic SHARED $<TARGET_OBJECTS:xeddsa_objects>)
     set_target_properties(xeddsa_dynamic PROPERTIES OUTPUT_NAME xeddsa)
+    set_target_properties(xeddsa_dynamic PROPERTIES
+       VERSION ${CMAKE_PROJECT_VERSION}
+       SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
+    )
+
     target_link_libraries(xeddsa_dynamic PUBLIC
         xeddsa_objects
         crypto_sign_objects
@@ -126,7 +126,7 @@
         crypto_stream_objects
         crypto_core_objects
         kernelrandombytes_objects
-        sodium_shared
+        sodium
     )
 
     if (WIN32)
@@ -157,12 +157,12 @@
 
 add_executable(xeddsa_test_static $<TARGET_OBJECTS:xeddsa_test_objects>)
 target_include_directories(xeddsa_test_static PRIVATE test)
-target_link_libraries(xeddsa_test_static xeddsa_static sodium_static)
+target_link_libraries(xeddsa_test_static xeddsa_static sodium)
 
 if (NOT DEFINED EMSCRIPTEN)
     add_executable(xeddsa_test_dynamic $<TARGET_OBJECTS:xeddsa_test_objects>)
     target_include_directories(xeddsa_test_dynamic PRIVATE test)
-    target_link_libraries(xeddsa_test_dynamic xeddsa_dynamic sodium_shared)
+    target_link_libraries(xeddsa_test_dynamic xeddsa_dynamic sodium)
 endif ()
 
 ################
