=== ref10/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(ref10)
+project(ref10 LANGUAGES C)
 
 include(CTest)
 
@@ -331,5 +331,3 @@
 
 set(crypto_verify_sources
     crypto_verify/verify.c
-)
-
