=== debian/changelog ===
libxeddsa (2.0.0+20231128.d725c81-1) unstable; urgency=medium

  * New upstream snapshot
  * Add debian/clean (Closes: #1048182)

 -- Martin <debacle@debian.org>  Thu, 26 Dec 2024 22:51:03 +0000

libxeddsa (2.0.0+20221109.06a02c8-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062732

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 07:17:19 +0000
