=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Uploaders: Martin <debacle@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: cmake,
+Build-Depends: dpkg-dev (>= 1.22.5),
+	       cmake,
 	       debhelper-compat (= 13),
 	       doxygen,
 	       libsodium-dev,
@@ -22,8 +23,8 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libxeddsa2 (= ${binary:Version}),
-         ${misc:Depends},
+Depends: libxeddsa2t64 (= ${binary:Version}),
+	 ${misc:Depends},
 	 ${sphinxdoc:Depends},
 Pre-Depends: ${misc:Pre-Depends}
 Description: toolkit around Curve25519 and Ed25519 key pairs - development files
@@ -38,7 +39,10 @@
  .
  This package contains the development files.
 
-Package: libxeddsa2
+Package: libxeddsa2t64
+Provides: ${t64:Provides}
+Replaces: libxeddsa2
+Breaks: libxeddsa2 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
